package com.dragonsoft.dcuc.approve.business.external;

import com.dragoninfo.dcuc.common.entity.ApiResultPage;
import com.dragoninfo.dcuc.common.entity.ApiSearchReq;
import com.dragonsoft.dcuc.approve.model.vo.dcuc.ApiOrgResultVo;
import com.dragonsoft.dcuc.approve.model.vo.dcuc.ApiPoliceResultVo;
import com.dragonsoft.dcuc.approve.model.vo.dcuc.OauthUserVO;

/**
 * <p>
 *
 * </p>
 *
 * @author huangzqa
 * @date 2021/7/12
 */
public interface IDcucBusiness {

    /**
     * 获取认证用户信息
     *
     * @param searchIdcard 查询的身份证号
     * @return 认证用户信息
     */
    OauthUserVO getOauthUserInfoByIdcard(String searchIdcard);

    /**
     * 获取机构信息
     *
     * @param orgCode 机构代码
     * @return 机构信息
     */
    ApiOrgResultVo orgInfo(String orgCode);

    /**
     * 获取机构列表
     *
     * @param apiSearchReq 请求参数
     * @return 机构列表
     */
    ApiResultPage<ApiOrgResultVo> orgPage(ApiSearchReq apiSearchReq);

    /**
     * 获取警员列表
     *
     * @param apiSearchReq 请求参数
     * @return 警员列表
     */
    ApiResultPage<ApiPoliceResultVo> policePage(ApiSearchReq apiSearchReq);

}
