package com.dragonsoft.dcuc.approve.facade;

import com.dragoninfo.dcuc.common.utils.ResponseUtil;
import com.dragonsoft.dcuc.approve.model.ApproveTaskClass;
import com.dragonsoft.dcuc.approve.model.req.ApproveTaskClassAddReqVO;
import com.dragonsoft.dcuc.approve.model.req.ApproveTaskClassUpdateReqVO;
import com.dragonsoft.dcuc.approve.model.resp.ApproveTaskClassDetailRespVO;
import com.dragonsoft.dcuc.approve.service.IApproveTaskClassService;
import com.dragonsoft.duceap.base.entity.http.ResponseDTO;
import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
import com.dragonsoft.duceap.core.search.Searchable;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *
 * </p>
 *
 * @author huangzqa
 * @date 2023/6/9
 */
@RestController
public class ApproveTaskClassFacade implements IApproveTaskClassFacade {

    private IApproveTaskClassService approveTaskClassService;

    @Autowired
    public void setApproveTaskClassService(IApproveTaskClassService approveTaskClassService) {
        this.approveTaskClassService = approveTaskClassService;
    }

    @Override
    public Page<ApproveTaskClassDetailRespVO> page(Searchable searchable) {
        return approveTaskClassService.page(searchable);
    }

    @Override
    public ResponseStatus delete(String id) {
        return approveTaskClassService.delete(id);
    }

    @Override
    public ResponseDTO<String> save(ApproveTaskClassAddReqVO approveTaskClassAddReqVO) {
        ResponseDTO<ApproveTaskClass> saveResp = approveTaskClassService.save(approveTaskClassAddReqVO);
        if (ResponseUtil.isFail(saveResp)) {
            return ResponseUtil.dtoFail(saveResp.getMessage());
        }
        ApproveTaskClass approveTaskClass = ResponseUtil.getResult(saveResp);
        return ResponseUtil.newInstance(approveTaskClass.getId());
    }

    @Override
    public ResponseDTO<String> update(ApproveTaskClassUpdateReqVO approveTaskClassUpdateReqVO) {
        ResponseDTO<ApproveTaskClass> updateResp = approveTaskClassService.update(approveTaskClassUpdateReqVO);
        if (ResponseUtil.isFail(updateResp)) {
            return ResponseUtil.dtoFail(updateResp.getMessage());
        }
        ApproveTaskClass approveTaskClass = ResponseUtil.getResult(updateResp);
        return ResponseUtil.newInstance(approveTaskClass.getId());
    }

    @Override
    public ResponseDTO<ApproveTaskClassDetailRespVO> detail(String id) {
        return approveTaskClassService.detail(id);
    }
}
