package com.dragonsoft.dcuc.approve.business.impl;

import com.dragoninfo.dcuc.common.http.SkipSslVerificationHttpRequestFactory;
import com.dragoninfo.dcuc.common.utils.ResponseUtil;
import com.dragonsoft.dcuc.approve.business.external.impl.NoticeBusinessImpl;
import com.dragonsoft.dcuc.approve.model.resp.bu.BuApproveSyncBizApproveReqVO;
import com.dragonsoft.dcuc.approve.model.resp.bu.BuApproveSyncBizDataReqVO;
import com.dragonsoft.dcuc.approve.model.resp.bu.BuApproveSyncReqVO;
import com.dragonsoft.dcuc.approve.properties.ApproveBuProperties;
import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
import com.dragonsoft.duceap.commons.util.UUIDUtils;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.dreamhead.moco.HttpServer;
import com.github.dreamhead.moco.Runner;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;
import org.springframework.web.client.RestTemplate;

import java.util.Date;

import static com.github.dreamhead.moco.Moco.*;

/**
 * <p>
 *
 * </p>
 *
 * @author huangzqa
 * @date 2023/11/14
 */
public class NoticeBusinessImplTest {
    static int port = 19001;
//
//    public static void main(String[] args) {
//        try {
//            NoticeBusinessImplTest.before();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }


    static String baseUrl = "http://127.0.0.1:" + port;

    static String syncToBuUrl = "/sync/tuBu";

    static String fullBusinessUrl = baseUrl + syncToBuUrl;

    static NoticeBusinessImpl noticeBusiness;

    public static Runner runner;


    @BeforeClass
    public static void before() throws Exception {
        HttpServer httpServer = httpServer(port, log());

        httpServer.request(by(uri(syncToBuUrl)))
                .response(pathResource("bu/buSuccess.json"));

        runner = Runner.runner(httpServer);

        runner.start();

        SkipSslVerificationHttpRequestFactory skipSslVerificationHttpRequestFactory
                = new SkipSslVerificationHttpRequestFactory();
        skipSslVerificationHttpRequestFactory.setReadTimeout(5000);
        skipSslVerificationHttpRequestFactory.setConnectTimeout(5000);
        RestTemplate restTemplate = new RestTemplate(skipSslVerificationHttpRequestFactory);
        ApproveBuProperties approveBuProperties = new ApproveBuProperties();
        approveBuProperties.setEnable(true);
        approveBuProperties.setSyncTaskUrl(fullBusinessUrl);

        ObjectMapper objectMapper = new ObjectMapper();
        // 忽略不对应的字段
        objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);

        noticeBusiness = new NoticeBusinessImpl();
        noticeBusiness.setRestTemplate(restTemplate);
        noticeBusiness.setApproveBuProperties(approveBuProperties);
        noticeBusiness.setDragonObjectMapper(objectMapper);
    }

    @Test
    public void baseReq() {

        BuApproveSyncReqVO buApproveSyncReqVO = new BuApproveSyncReqVO();
        buApproveSyncReqVO.setAppId("aaa");
        buApproveSyncReqVO.setAppName("ss");
        buApproveSyncReqVO.setCreateTime(new Date());
        buApproveSyncReqVO.setFinishTime(new Date());
        buApproveSyncReqVO.setCreaterId("sss");
        buApproveSyncReqVO.setLastReviewerIdCard("sss");
        buApproveSyncReqVO.setLastReviewerName("sssss");
        buApproveSyncReqVO.setLastReviewerUnitName("ss");
        buApproveSyncReqVO.setLastReviewerUnitCode("sssss");
        buApproveSyncReqVO.setTaskId("111");
        buApproveSyncReqVO.setCreaterId("sss");

        BuApproveSyncBizApproveReqVO buApproveSyncBizApproveReqVO = new BuApproveSyncBizApproveReqVO();
        buApproveSyncBizApproveReqVO.setTitle("ss");
        buApproveSyncBizApproveReqVO.setTaskClass("sss");
        buApproveSyncBizApproveReqVO.setTaskStatus("1");
        buApproveSyncBizApproveReqVO.setTaskTermStart(new Date());
        buApproveSyncBizApproveReqVO.setTaskTermEnd(new Date());

        BuApproveSyncBizDataReqVO buApproveSyncBizDataReqVO = new BuApproveSyncBizDataReqVO();
        buApproveSyncBizDataReqVO.setTaskInfo(buApproveSyncBizApproveReqVO);
        buApproveSyncReqVO.setBizData(buApproveSyncBizDataReqVO);

        ResponseStatus responseStatus = noticeBusiness.retryRequestSyncToBu(buApproveSyncReqVO);
        Assert.assertTrue(ResponseUtil.isSuccess(responseStatus));
    }
}